/********************************************************************
	filename: 	txtCRenderer.h
	author:		Morock
	created:	3:10:2007   17:26	
	purpose:	Text render sample
*********************************************************************/

#pragma once 

#include "dxstdafx.h"
#include <d3d9types.h>

#define D3DFVF_VIRTUALSCREEN_VERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)
//Virtual screen declarations
struct gpsvsVIRTUALSCREEN_VERTEX
{
	D3DXVECTOR3 p;			// Position
	D3DXVECTOR2 UV;
	D3DXVECTOR3 dif_color;	// The color
}; 


class gpsvsCRenderer
{
public:
//BEG - Public variables

//END - Public variables

	gpsvsCRenderer();
	~gpsvsCRenderer();

	//GRS_VisualSystem Initialization
	
	/*
		const WCHAR strWindowTitle=L"GPS - Visualisation",			- The window name
		HINSTANCE hInstance = NULL,									- Window hInstance
		HICON hIcon = NULL,											- Icon handler
		HMENU hMenu = NULL,											- Menu handler
		int iWindowX = CW_USEDEFAULT, int iWindowY = CW_USEDEFAULT,	- Window size
		int iPixWidth = 640, int iPixHeight = 480					- Window pixel rate			
	*/
	static HRESULT INIT(const WCHAR* strWindowTitle=L"GPS - Visualisation",
				HINSTANCE hInstance = NULL, 
				HICON hIcon = NULL, HMENU hMenu = NULL,
				int iWindowX = CW_USEDEFAULT, int iWindowY = CW_USEDEFAULT,
				int iPixWidth = 640, int iPixHeight = 480);

protected:
//BEG - Protected variables
	//Global transformation data (use this for all meshes!!!)
	static D3DXVECTOR3 g_v3Trans;			//Translation vector for WORLD MATRIX computing
	static D3DXMATRIX	g_matCamera;		//Camera matrix for VIEW matrix computing
	static float		g_fAspect;			//Aspect ratio for PROJECTION matrix computing
	static gpsvsVIRTUALSCREEN_VERTEX vsv[4];

	static D3DXVECTOR2 g_ScreenSize;// size of screen in pixels
//END - Protected variables

//-----------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------
	//Render properties setup
	static void SetupRenderProperties (IDirect3DDevice9* pd3dDevice);
	//Virtual Screen Vertex Buffer Init
	//static void CreateVertex(float fVertSize, D3DXVECTOR3 v3VertexColor);

	//BEG - CALLBACK D3DX9Util functions
	// Rejects any devices that aren't acceptable by returning false
	static bool CALLBACK IsDeviceAcceptable( D3DCAPS9* pCaps, D3DFORMAT AdapterFormat, 
									D3DFORMAT BackBufferFormat, bool bWindowed, void* pUserContext );
	// Before a device is created, modify the device settings as needed
	static bool CALLBACK ModifyDeviceSettings( DXUTDeviceSettings* pDeviceSettings, const D3DCAPS9* pCaps, void* pUserContext );
	// Create any D3DPOOL_MANAGED resources here 
	static HRESULT CALLBACK OnCreateDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc,
									 void* pUserContext );
	// Release resources created in the OnCreateDevice callback here
	static void CALLBACK OnDestroyDevice( void* pUserContext );
	// Create any D3DPOOL_DEFAULT resources here 
	static HRESULT CALLBACK OnResetDevice( IDirect3DDevice9* pd3dDevice, 
									const D3DSURFACE_DESC* pBackBufferSurfaceDesc, void* pUserContext );
	// Release resources created in the OnResetDevice callback here 
	static void CALLBACK OnLostDevice( void* pUserContext );
	// Handle updates to the scene
	static void CALLBACK OnFrameMove( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime, void* pUserContext );
	// Render the scene 
	static void CALLBACK OnFrameRender( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime, void* pUserContext );
	// Handle messages to the application 
	static LRESULT CALLBACK MsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, 
								bool* pbNoFurtherProcessing, void* pUserContext );
	//END - D3DX9Util functions
};